/**
 * Created by ywu on 15/7/28.
 */
const {
  Component,
  Animated,
  View,
  TouchableWithoutFeedback,
} = React;

const React = require('react-native');


/**
 * Thumb component of the switch
 */
class Thumb extends Component {
  render() {
    return <View />;
  }
}


/**
 * Switch
 */
class Switch extends Component {

  _onEvent(event) {
    // console.log('got event', event);
    const newState = event.nativeEvent;

    if (this.props.onCheckedChange) {
      this.props.onCheckedChange(newState);
    }
  }

  render() {
    const touchableProps = {};
    if (!this.props.disabled) {
      Object.assign(touchableProps, {
        onPress: this.props.onPress,
        onPressIn: this.props.onPressIn,
        onPressOut: this.props.onPressOut,
        onLongPress: this.props.onLongPress,
      });
    }

    this.props.style = [Switch.defaultProps.style, this.props.style || {}];

    return (
      <TouchableWithoutFeedback {...touchableProps}>
        <NativeSwitch {...this.props} onChange={this._onEvent.bind(this)}/>
      </TouchableWithoutFeedback>
    );
  }
}

Switch.propTypes = {
  ...TouchableWithoutFeedback.propTypes,
  checked: React.PropTypes.bool,
  thumbRadius: React.PropTypes.number,
  onColor: React.PropTypes.string,
  offColor: React.PropTypes.string,
  thumbOnColor: React.PropTypes.string,
  thumbOffColor: React.PropTypes.string,
  rippleLayerColor: React.PropTypes.string,
  slidingAniDuration: React.PropTypes.number,
  onCheckedChange: React.PropTypes.func,
};

Switch.defaultProps = {
  style: {
    width: 36, height: 14,
    marginBottom: 10,
  },
};


module.exports = Switch;
